/* This is  -*- C++ -*-  */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  \file  helpfunction.hpp
///  \brief Implements some methods needed, surely not optimal.
///  \author Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  \date   2010-09-29
///
///  Copyright (C) 2010 Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  Distributed  under  the  terms  of  the  GNU  General  Public  License (GPL)
///  http://www.gnu.org/licenses/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef HELPFUNCTION_HPP_
#define HELPFUNCTION_HPP_

#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>
#include "defs.h"

namespace help
{
template <typename T>
std::string numberToString(T i){
    std::stringstream ss;
    ss<<i;
    return ss.str();
}

bool doesFileExists(std::string strFilename);

My_Long_Int factorial(unsigned int a);
My_Long_Int binomial_coefficient(unsigned int n, unsigned int i);
My_Long_Int GaussBinomialBinary(unsigned int n, unsigned int k);
My_Long_Int GaussBinomial(unsigned int n, unsigned int k, unsigned int q);
My_Long_Int power(unsigned int q, unsigned int n);

template<typename RING>
My_Long_Int nonredundantSubmodules(const unsigned int* const type, unsigned int n)
{
    unsigned int k(0);
    for(unsigned int i=0; i<RING::chainlength(); i++)
    {
        k+=type[i];
    }
    My_Long_Int res = RING::SubmoduleQty(type, n);
    for(unsigned int i=k; i<n; i++)
    {
        My_Long_Int loc_res = nonredundantSubmodules<RING>(type, i);
        loc_res *= help::factorial(n);
        loc_res /= help::factorial(n-i);
        loc_res /= help::factorial(i);
        res -= loc_res;
    }

    return res;
}

template<typename T>
std::ostream& print(std::ostream& os, const std::vector<T>& vec, const std::string& seperator)
{
    typename std::vector<T>::const_iterator vecIter(vec.begin());
    typename std::vector<T>::const_iterator vecIterEnd(vec.end());

    for (; vecIter < vecIterEnd; ++vecIter)
    {
        os << *vecIter << seperator;
    }
    return os;
}
}

#endif /*HELPFUNCTION_HPP_*/
